Package owl.automaton

## Class AbstractCachedStatesAutomaton<S,​A extends OmegaAcceptance>

- java.lang.Object
- - owl.automaton.AbstractCachedStatesAutomaton<S,​A>

- All Implemented Interfaces:
    `Automaton<S,​A>`
  Direct Known Subclasses:
    `AbstractImplicitAutomaton`, `DeterministicConstructions.CoSafety`, `DeterministicConstructions.FgSafety`, `DeterministicConstructions.GCoSafety`, `DeterministicConstructions.GfCoSafety`, `DeterministicConstructions.Safety`, `DeterministicConstructions.Tracking`, `LegacyFactory`, `NonDeterministicConstructions.CoSafety`, `NonDeterministicConstructions.FgSafety`, `NonDeterministicConstructions.GfCoSafety`, `NonDeterministicConstructions.Safety`, `NonDeterministicConstructions.Tracking`, `TwoPartAutomaton`

      public abstract class AbstractCachedStatesAutomaton<S,​A extends OmegaAcceptance>
      extends Object
      implements Automaton<S,​A>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface owl.automaton.Automaton

      `Automaton.EdgeMapVisitor<S>, Automaton.EdgeTreeVisitor<S>, Automaton.EdgeVisitor<S>, Automaton.PreferredEdgeAccess, Automaton.Property, Automaton.Visitor<S>`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractCachedStatesAutomaton()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `accept​(Automaton.EdgeMapVisitor<S> visitor)` |
    `void` | `accept​(Automaton.EdgeTreeVisitor<S> visitor)` |
    `void` | `accept​(Automaton.EdgeVisitor<S> visitor)` |
    `protected Set<S>` | `cache()` |
    `Set<S>` | `states()` | The set of all from the initial states reachable states in this automaton.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface owl.automaton.Automaton

      `accept, acceptance, edge, edgeMap, edges, edges, edgeTree, factory, initialStates, is, name, onlyInitialState, predecessors, preferredEdgeAccess, size, successor, successors, successors`

- - ### Constructor Detail

    - #### AbstractCachedStatesAutomaton

          public AbstractCachedStatesAutomaton()

  - ### Method Detail

    - #### states

          public final Set<S> states()

      Description copied from interface: `Automaton`
      The set of all from the initial states reachable states in this automaton.
      Specified by:
        `states` in interface `Automaton<S,​A extends OmegaAcceptance>`
      Returns:
        All reachable states

    - #### accept

          public final void accept​(Automaton.EdgeVisitor<S> visitor)

      Specified by:
        `accept` in interface `Automaton<S,​A extends OmegaAcceptance>`

    - #### accept

          public final void accept​(Automaton.EdgeMapVisitor<S> visitor)

      Specified by:
        `accept` in interface `Automaton<S,​A extends OmegaAcceptance>`

    - #### accept

          public final void accept​(Automaton.EdgeTreeVisitor<S> visitor)

      Specified by:
        `accept` in interface `Automaton<S,​A extends OmegaAcceptance>`

    - #### cache

          @Nullable
          protected final Set<S> cache()